# version 430

uniform mat4 view, proj, model, normalMat; //view_proj = camera
uniform mat3 M3x3, V3x3;

in vec3 position; 
in vec2 uv; 
in vec3 normal;
in vec3 tangent;
in vec3 bitangent;

out vec3 worldNormal;
out vec3 worldPos;
out vec2 texCoord;
out vec3 _normal;
out vec3 _tangent;
out vec3 _bitangent;

void main(){
    texCoord = uv;

	//vertexNormal_cameraspace = MV3x3 * normalize(vertexNormal_modelspace);
    //vertexTangent_cameraspace = MV3x3 * normalize(vertexTangent_modelspace);
    //vertexBitangent_cameraspace = MV3x3 * normalize(vertexBitangent_modelspace);

    worldPos = vec3(model * vec4(position, 1));
	worldNormal = vec3(normalMat * vec4(normal, 0.0));

	_normal = normalize(normal);
	_tangent = normalize(tangent);
	_bitangent = normalize(bitangent);

	/*_normal = normal;
	_tangent = tangent;
	_bitangent = bitangent;*/

    gl_Position = proj * view * model * vec4(position,1);
}
